$(function () {
  var AjaxHandler = new AjaxHandlePosts();
  AjaxHandler.init();
});


class AjaxHandlePosts {

  OffsetInput = $(".offset-input-posts");
  OffsetInitial = this.OffsetInput.val();
  Offset = this.OffsetInput.val();
  CategoryInput = $(".category-input-posts");
  Category = this.CategoryInput.val();
  YearInput = $(".year-input-posts");
  Year = this.YearInput.val();
  ArchiveInput = $(".archive-input-posts");
  Archive = this.ArchiveInput.val();

  Data;

  PhpAction = "posts_ajax_handle";

  Container = $(".posts-section__posts");
  ContainerLoadMore = $(".posts-section__posts");
  ContainerButtonLoadMore = $(".LoadMorePostsBtn");
  ButtonLoadMore = $(".load-more-posts");

  //* Getters

  getData() {
    return this.Data;
  }

  //* Setters

  setOffset(Offset) {
    return this.Offset = Offset;
  }

  setCategory(Category) {
    return this.Category = Category;
  }

  setYear(Year) {
    return this.Year = Year;
  }

  setArchive(Archive) {
    return this.Archive = Archive;
  }

  //* public functions

  showContainerButtonLoadMore() {
    this.ContainerButtonLoadMore.removeClass("d-none");
  }

  hideContainerButtonLoadMore() {
    this.ContainerButtonLoadMore.addClass("d-none");
  }

  showLoading() {
    let body = document.body;
    body.classList.add("loading");
    this.ButtonLoadMore.addClass("btn-loading");
  }

  hideLoading() {
    let body = document.body;
    body.classList.remove("loading");
    this.ButtonLoadMore.removeClass("btn-loading");
  }

  loadMoreClickAction() {
    var self = this;
    this.ButtonLoadMore.click(function (e) {
      e.preventDefault();
      self.loadMore();
    });
  }

  loadMore() {
    this.initArgs();
    var self = this;

    $.ajax({
      type: "POST",
      url: myAjax.ajaxurl,
      data: this.getData(),
      beforeSend: function () {
        self.showLoading();
      },
      success: function (response) {
        self.ContainerLoadMore.html(self.ContainerLoadMore.html() + response);
        var newOffset = parseInt(self.Offset) + parseInt(self.OffsetInitial);
        self.OffsetInput.val(newOffset);
        self.setOffset(newOffset);
        self.isLoadMore();
      },
      complete: function () {
        self.hideLoading();
      }
    });

  }

  isLoadMore() {

    this.initArgs();
    var self = this;

    $.ajax({
      type: "POST",
      url: myAjax.ajaxurl,
      data: this.getData(),

      success: function (response) {
        if (!$.trim(response)) {
          // response is blank
          self.hideContainerButtonLoadMore();

        } else {
          self.showContainerButtonLoadMore();

        }
      }

    });
  }

  /**
   * @param bool withOffset
   */
  initArgs() {
    this.Data = {
      action: this.PhpAction,
    };
    this.setOffset(this.OffsetInput.val());
    this.Data.ajax_offset = this.Offset;
    this.setCategory(this.CategoryInput.val());
    this.Data.ajax_category = this.Category;
    this.setYear(this.YearInput.val());

    this.Data.ajax_year = this.Year;
    this.setArchive(this.ArchiveInput.val());
    this.Data.ajax_archive = this.Archive;
  }

  init() {
    this.isLoadMore();
    this.loadMoreClickAction();
  }
}
